
let Hook = require('./lib/instance-hooks');
let LS = require('./scripts/LaunchScript');
const InstanceHook = new Hook();
let Scripts = require('./scripts/index');

let cluster = require('cluster');

if (cluster.isMaster) {
    Scripts.RunHook().then(function (thened) {
        cluster.InstanceHook = InstanceHook;
        Scripts.AlertDispatcher()
            .then(function () {
                console.log('Alerted');
            })
            .catch(function (error) {
                console.log(error);
            });
        let cpus = require('os').cpus().length;
        console.log('Forking S_Loc_Instance Version', require('./package.json').version);
        for (let i = 0; i < cpus; i += 1) {
            cluster.fork();
        }
    }).catch(function (err) {
        console.log('Failed To Run ', err);
    });
} else {
    let App = require('./app/index').App;

    App.listen(3000, function (err) {
        if (err) return console.log(err);
        console.log('Worker', cluster.worker.id, 'listening on 3000');
    })
}
