
let DynamoParam = require('./dynamo_param');

function DynamoItem(model, values) {

    this.values = (!values) ? {} : values;
    this.updates = {};
    if (model) {
        this.model = model;
        this.sort_keys = model.sort_keys;
        this.attributes = model.sort_keys;
        this.tablename = model.tablename;
        ParseModel(this);
    }


    function ParseModel(it) {
        if (it.values) {
            if (it.values.from) {

            } else {

            }
        }

    }

    this.checkIntegrity = async function() {
        if (!this.sort_keys) throw 'Error: No Sort_Keys Present';
        if (!this.attributes) throw 'Error: No Attributes Present';
        if (!this.tablename) throw 'Error: No TableName Present';
    }

}

DynamoItem.prototype.addDynamoValues = function (values, callback) {
    let it = this;
    if (callback) {
        ParseValues(it).then(function () {
            return callback(null);
        }).catch(callback);
    } else return new Promise(async function (result) {
        try {
            await ParseValues(it);
            return result(Promise.resolve());
        } catch (e) {
            return result(Promise.reject(e));
        }
    });

    async function ParseValues(it) {
        try {
            await it.checkIntegrity();
            if (!values) throw "No Values Provided";
            let keys = it.sort_keys,
                actualKeys = await Object.keys(keys),
                keyLength = actualKeys.length,
                attributes = it.attributes,
                attKeys = await Object.keys(attributes),
                attLength = attKeys.length,
                valueKeys = await Object.keys(values),
                valueLengths = valueKeys.length;
            if (valueLengths < keyLength) throw 'Provided less than or equal the number of keys allowed, which is '+keyLength;
            if (it.parameters) {
                await HandleKeys();
                await HandleAtts();
                function HandleKeys() {
                    return new Promise(function (thened) {
                        let err;
                        for(let i = 0; i < keyLength; i++) {
                            let key = actualKeys[i], present = values[key], currentSort = it.parameters.sorts[key];
                            if (!present) {
                                err = "Error: No Sort Key "+key+" Not Provided";
                                break;
                            } else {
                                if (!currentSort) {
                                    it.parameters.sorts[key] = new DynamoParam('none', present);
                                } else {
                                    currentSort.setFromDynamo(present);
                                }
                            }
                        }
                        if (err) return thened(Promise.reject(err));
                        return thened(Promise.resolve());
                    })
                }
                function HandleAtts() {
                    return new Promise(function (thened) {
                        let err;
                        for (let i = 0; i < valueLengths; i++) {
                            let key = valueKeys[i], present = values[key], currentAtt = it.parameters.attributes[key];
                            if (!it.sort_keys[key]) {
                                if (!present) {
                                    err = "Error: No Attribute Key "+key+" Not Provided";
                                    break;
                                } else {
                                    if (!currentAtt) {
                                        it.parameters.attributes[key] = new DynamoParam('none', present);
                                    } else {
                                        currentAtt.setFromDynamo(present);
                                    }
                                }
                            }

                        }
                        if (err) return thened(Promise.reject(err));
                        return thened(Promise.resolve());
                    })
                }

            } else {
                await HandleKeysP();
                await HandleAttsP();
                function HandleKeysP() {
                    return new Promise(function (thened) {
                        let err;
                        for (let i = 0; i < keyLength; i++) {
                            let key = actualKeys[i], present = values[key];
                            if (!present) {
                                err = "Error: No Sort - No Params - Key "+key+" provided for " + values;
                                break;
                            } else {
                                if (!it.parameters) it.parameters = {sorts:{}, attributes:{}};
                                it.parameters.sorts[key] = new DynamoParam('none', present);
                            }
                        }
                        if (err) return thened(Promise.reject(err));
                        return thened(Promise.resolve());
                    })
                }
                function HandleAttsP() {
                    return new Promise(function (thened) {
                        let err;
                        for (let i = 0; i < valueLengths; i++) {
                            let key = valueKeys[i], present = values[key];
                            if (!it.sort_keys[key]) {
                                if (!present) {
                                    err = "Error: No Attribute - No Params - Key "+key+" provided";
                                    break;
                                } else {
                                    if (!it.parameters) it.parameters = {sorts:{}, attributes:{}};
                                    it.parameters.attributes[key] = new DynamoParam('none', present);
                                }
                            }
                        }
                        if (err) return thened(Promise.reject(err));
                        return thened(Promise.resolve());
                    })
                }
            }
        } catch(e) {
            throw e
        }
    }
};

DynamoItem.prototype.toDynamoUpdateObject = function (action) {

    let it = this;
    let final = {};

    return new Promise(async function (result) {
        try {
            return result(await Handle(it));
        } catch(e) {
            return result(Promise.reject(e));
        }
    });


    async function Handle(it) {
        if (!it.tablename) throw "Error: No TableName Present";
        if (!it.parameters) throw "Error: No Parameters Present";
        let sortsObject = it.parameters.sorts,
            sortKeys = Object.keys(sortsObject),
            keyL = sortKeys.length;
        let err;
        for (let i = 0; i < keyL; i++) {
            let key = sortKeys[i], param = sortsObject[key];
            if (!param) {
                err = "Error: No Sort Key "+key+" Found In Parameter.Sorts"
                break;
            }
            if (!final.Key) final.Key = {};
            final.Key[key] = param.dynamoObject();
        }
        if (err) throw err;

        let attObject = it.parameters.attributes,
            attKeys = Object.keys(attObject),
            attL = attKeys.length;

        let ExpressionValues = {};
        let ExpressionNames = {};
        let Expression = "";
        let sortCount = 0;
        let attCount = 0;

        let doAction = (!action) ? 'SET' : action;

        for (let i = 0; i < attL; i++) {
            let key = attKeys[i], param = attObject[key];
            if (!param) {
                err = "Error: No Sort Key "+key+" Found In Parameter.Sorts"
                break;
            }
            if (!key || typeof key !== 'string') {
                err = "No Such Key, Or Invalid Key " + key;
                break;
            }
            if (param) {
                let exptag, valtag;
                if (doAction === 'SET') {
                    if (key.indexOf('_') > -1) {
                        let tagers = key.split("_"), tag1 = tagers[0].substring(0,2), tag2 = tagers[1].substring(0,2), final = (tag1+tag2);
                        exptag = ("#"+final.toUpperCase());
                        valtag = ":"+final;
                    } else {
                        exptag = "#"+key.substring(0,2).toUpperCase();
                        valtag = ":"+key.substring(0,2);
                    }
                    ExpressionValues[valtag] = param.dynamoObject();
                    ExpressionNames[exptag] = key;
                    if (i < attL - 1) {
                        Expression += " "+exptag+" = "+valtag+",";
                    } else {
                        Expression += " "+exptag+" = "+valtag;
                    }
                } else if (doAction === "REMOVE") {
                    if (key.indexOf('_') > -1) {
                        let tagers = key.split("_"), tag1 = tagers[0].substring(0,2), tag2 = tagers[1].substring(0,2), final = (tag1+tag2);
                        exptag = ("#"+final.toUpperCase());
                        valtag = ":"+final;
                    } else {
                        exptag = "#"+key.substring(0,2).toUpperCase();
                        valtag = ":"+key.substring(0,2);
                    }
                    ExpressionValues[valtag] = param.dynamoObject();
                    if (i < attL - 1) {
                        Expression += " "+key+",";
                    } else {
                        Expression += " "+key;
                    }
                }
                attCount += 1;
            }
        }
        switch (doAction) {
            default:
            case 'SET':
                final.ExpressionAttributeValues = ExpressionValues;
                final.ExpressionAttributeNames = ExpressionNames;
                break;
            case 'REMOVE':break;

        }
        final.UpdateExpression = doAction+Expression;
        final.TableName = it.tablename;
        return Promise.resolve(final);
    }
};

DynamoItem.prototype.updateParameter = function (param, value, iskey){
    let params = this.parameters;
    if (!params) this.parameters = {};
    params = this.parameters;
    let keys = params.sorts, attributes = params.attributes;
    if (iskey) {
        if (keys) {
            let l = Object.keys(keys).length, exists = keys[param];
            if (!exists) {
                keys[param] = new DynamoParam(value);
            } else {
                return console.log('Error : Cannot Set An Existing Key', param);
            }
        } else {
            this.parameters.sorts = {};
            this.parameters.sorts[param] = new DynamoParam(value);
        }
    } else {
        let current = attributes[param];
        if (!current) {
            this.parameters.attributes[param] = new DynamoParam(value);
        } else {
            current.set(value);
        }
    }

};

module.exports = DynamoItem;