function DynamoParam(data, dynamo) {
    if (typeof data === 'object') {
        let value = data.S || data.N;
        if (!value) {
            //Object not from Dynamo
            this.type = "Object"; this.short_hand = "S";
            this.value = data;
            this.js_type = typeof value;
        } else {
            if (!!data.S) {
                this.type = "String";
                this.short_hand = 'S';
            } else if (!!data.N) {
                this.type = "Number"; this.short_hand = "N";
            }
            this.value = value;
            this.js_type = typeof value;
        }
    } else if (data ==="none" && dynamo) {
        this.setFromDynamo(dynamo);
    } else {
            let type = (typeof data);
        switch (type) {
            case"string":
                let value = data;
                if (value.indexOf('{') === 0 && value.indexOf('}') > -1) {
                    this.type = "Object"; this.short_hand = 'S';
                    this.js_type = 'object';
                    this.value = JSON.parse(value);
                    return;
                } else {
                    this.type = "String"; this.short_hand = 'S';
                    this.js_type = typeof value;
                    this.value = value;
                    return;
                }
            case"number":
                this.type = "Number"; this.short_hand = "N";
                this.js_type = typeof data;
                this.value = data;
                return;
            default:return console.log('DYNAMOPARAM_ERROR: Setting', type, 'Failed Since Not Supported');
        }
    }
}

DynamoParam.prototype.set = function (value, key) {
    let type = typeof value;
    if (key && typeof key === 'string') return this.value[key] = value;
    if (type === this.js_type) return this.value = value;
    else {
        switch (type) {
            case"string":
                this.type = "String"; this.short_hand = 'S'; break;
            case"number":
                this.type = "Number"; this.short_hand = "N"; break;
            default:break;
        }
        this.value = value;
        this.js_type = typeof value;
    }
};

DynamoParam.prototype.setFromDynamo = function (value) {
    let it = this;
    let keys = Object.keys(value), keyL = keys.length;
    for (let i = 0 ; i < keyL; i++) {
        let key = keys[i];
        if (key === "N") {
            it.type = "Number"; it.short_hand = key; it.value = value[key];
            it.js_type = typeof it.value ;
        } else if (key ==="S") {
            it.type = "String"; it.short_hand = key; it.value = value[key];
            it.js_type = typeof it.value ;
        } else {
            it.type = "unknown"; it.short_hand = key; it.value = value[key];
            it.js_type = typeof it.value ;
        }
    }
};

DynamoParam.prototype.dynamoObject = function() {
    if (this.type === "Object") return {
        "S": JSON.stringify(this.value)
    };
    let short = this.short_hand, object = {};
    object[short] = this.value;
    return object
};

DynamoParam.prototype.toJSON = function () {
    return {
        short_hand: this.short_hand,
        value: this.value,
        type: this.type
    };
};

module.exports = DynamoParam;